#include "stdafx.h"
#include <string.h>
#include <stdio.h>

typedef HRESULT (WINAPI *DirectDrawCreateEx_Type)(GUID FAR *, LPVOID, REFIID, IUnknown FAR *);
typedef HRESULT (WINAPI *CreateSurface_Type)(LPDIRECTDRAW7, LPDDSURFACEDESC2, LPDIRECTDRAWSURFACE7 FAR *, IUnknown FAR *);
typedef HRESULT (WINAPI *SetHWnd_Type)(LPDIRECTDRAWCLIPPER, DWORD, HWND);
typedef HRESULT (WINAPI *Blt_Type)(LPDIRECTDRAWSURFACE7, LPRECT, LPDIRECTDRAWSURFACE7, LPRECT, DWORD, LPDDBLTFX);
typedef HRESULT (WINAPI *DirectSoundCreate_Type)(DWORD, DWORD, DWORD);
typedef HRESULT (WINAPI *SetCooperativeLeve_Type)(LPDIRECTDRAW7, HWND, DWORD);
typedef HRESULT (WINAPI *Flip_Type)(LPDIRECTDRAWSURFACE7, LPDIRECTDRAWSURFACE7, DWORD);

#include <pshpack1.h>
typedef struct
{
	WORD bfType;
	DWORD bfSize;
	WORD bfReserved1;
	WORD bfReserved2;
	DWORD bfOffBits;
	DWORD biSize;
	DWORD biWidth;
	DWORD biHeight;
	WORD biPlanes;
	WORD biBitCount;
	DWORD biCompression;
	DWORD biSizeImage;
	DWORD biXPixPerMeter;
	DWORD biYPixPerMeter;
	DWORD biClrUsed;
	DWORD biClrImporant;
}BITMAPHEADER;
#include <poppack.h>

DirectSoundCreate_Type pDirectSoundCreate;
SetCooperativeLeve_Type pSetCooperativeLevel;
Flip_Type pFlip;
WNDPROC pWindowProc = 0;
LPDIRECTDRAWSURFACE7 lpDDSPrim;
LPDIRECTDRAWSURFACE7 lpDDSBack;
CreateSurface_Type pCreateSurface;
Blt_Type pBlt = 0;
SetHWnd_Type pSetHWnd;
RECT rWinSize;
RECT rClientSize;
char WinName[128];
BOOL bMinimize = 0;
BOOL bFullScreen = 0;

HRESULT WINAPI DirectSoundCreate(
	DWORD lpcGuid,
	DWORD ppDS,
	DWORD pUnkOuter
)
{
	return (*pDirectSoundCreate)(lpcGuid, ppDS, pUnkOuter);
}

void OutBitmap(LPDIRECTDRAWSURFACE7 lpdds, RECT *rect)
{
	BITMAPHEADER bmh;
	DDSURFACEDESC2 ddsd;
	char path[MAX_PATH];
	SYSTEMTIME time;
	FILE *fp;
	BYTE *line;
	int bits;
	int x,y;
	WORD *p;
	RECT sub;

	GetLocalTime(&time);
	sprintf(path, "ScreenShot\\TWCI_%i_%i_%i_%i_%i_%i.bmp",
		time.wYear, time.wMonth, time.wDay, time.wHour, time.wMinute, time.wSecond);
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_PITCH | DDSD_LPSURFACE | DDSD_PIXELFORMAT;
	ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
	ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB;
	if(lpdds->Lock(0, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_READONLY, 0) != DD_OK){
		MessageBox(0, path, "", MB_OK);
		return;
	}
	sub.top = 0;
	sub.left = 0;
	sub.right = ddsd.dwWidth;
	sub.bottom = ddsd.dwHeight;
	if(!rect) rect = &sub;
	if(ddsd.ddpfPixelFormat.dwRBitMask & 0x8000) bits = 16;
	else bits = 15;
	fp = fopen(path, "wb");
	if(!fp){
		lpdds->Unlock(&rClientSize);
		return;
	}
	ZeroMemory(&bmh, sizeof(bmh));
	memcpy(&bmh.bfType, "BM", 2);
	bmh.bfOffBits = sizeof(bmh);
	bmh.biSize = 40;
	bmh.biWidth = rect->right - rect->left;
	bmh.biHeight = rect->bottom - rect->top;
	bmh.biPlanes = 1;
	bmh.biBitCount = 24;
	bmh.biSizeImage = bmh.biWidth*bmh.biHeight*3;
	bmh.bfSize = sizeof(bmh) + bmh.biSizeImage;
	fwrite(&bmh, sizeof(bmh), 1, fp);
	line = (BYTE *)malloc(bmh.biWidth*3);
	for(y = rect->bottom - 1; y >= rect->top; y --){
		p = (WORD *)((char *)ddsd.lpSurface + ddsd.lPitch*y + rect->left*2);
		if(bits == 16){
			for(x = rect->left; x < rect->right; x ++){
				*(line + x*3) = (*p & 0x001f) << 3;
				*(line + x*3 + 1) = (*p & 0x07e0) >> 3;
				*(line + x*3 + 2) = (*p & 0xf800) >> 8;
				p ++;
			}
		}
		else{
			for(x = rect->left; x < rect->right; x ++){
				*(line + x*3) = (*p & 0x001f) << 3;
				*(line + x*3 + 1) = (*p & 0x03e0) >> 2;
				*(line + x*3 + 2) = (*p & 0x7c00) >> 7;
				p ++;
			}
		}
		fwrite(line + rect->left*3, bmh.biWidth*3, 1, fp);
	}
	free(line);
	fclose(fp);
	lpdds->Unlock(0);
}

void *SetHook(void *target, DWORD offset, void *proc)
{
	void *org;
	org = *(void  **)(*(DWORD *)target + offset);
	*(void **)(*(DWORD *)target + offset) = proc;
	return org;
}

void Indicate(HWND hwnd, int prio, BOOL rep, BOOL lock)
{
	char s[128], p[4][6] = {"SLEEP", "LOW", "NORM", "HIGH"};
	if(bMinimize) prio = 0;
	strcpy(s, WinName);
	strcat(s, "  P:");
	strcat(s, p[prio]);
	strcat(s, "  M:");
	if(!rep && !lock) strcat(s, "NORM");
	if(rep && lock) strcat(s, "REP/LOCK");
	if(rep && !lock) strcat(s, "REP");
	if(!rep && lock) strcat(s, "LOCK");
	SetWindowText(hwnd, s);
}

LRESULT CALLBACK extWindowProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	char path[MAX_PATH];
	char s[32];
	static BOOL bl = 0,br = 0, bm = 0;
	static BOOL bclick = 0;
	static BOOL brepeat = 0, block = 0;
	static int prio = 2;

	DWORD prioclass[] = {0, IDLE_PRIORITY_CLASS, NORMAL_PRIORITY_CLASS, HIGH_PRIORITY_CLASS};
	POINT point;

	switch(message){
	case WM_TIMER:
		if(wparam == 1234){
			MoveWindow(hwnd, rWinSize.left, rWinSize.top, rWinSize.right, rWinSize.bottom, TRUE);
			KillTimer(hwnd, 1234);
			Indicate(hwnd, prio, brepeat, block);
			SetTimer(hwnd, 1235, 50, NULL);
			return false;
		}
		if(wparam == 1235){
			if(bMinimize && bFullScreen) Sleep(40);
			if(bl && brepeat || bl && bclick){
				GetCursorPos(&point);
				ScreenToClient(hwnd, &point);
				lparam = point.x + (point.y << 16);
				bclick ^= 1;
				wparam = 0;
				if(br) wparam |= MK_RBUTTON;
				if(bm) wparam |= MK_MBUTTON;
				if(GetKeyState(VK_CONTROL) & 0x8000) wparam |= MK_CONTROL;
				if(GetKeyState(VK_SHIFT) & 0x8000) wparam |= MK_SHIFT;
				if(bclick) return (*pWindowProc)(hwnd, WM_LBUTTONUP, wparam, lparam);
				else return (*pWindowProc)(hwnd, WM_LBUTTONDOWN, wparam | MK_LBUTTON, lparam);
			}
			return false;
		}
		break;
	case WM_NCACTIVATE:
		if(bFullScreen) break;
		if(!wparam){
			SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);
			Indicate(hwnd, 1, brepeat, block);
		}
		else{
			SetPriorityClass(GetCurrentProcess(), prioclass[prio]);
			Indicate(hwnd, prio, brepeat, block);
		}
		DefWindowProc(hwnd,message,wparam,lparam);
		return false;
	case WM_SIZE:
		if(wparam == SIZE_MINIMIZED){
			SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);
			bMinimize = 1;
			Indicate(hwnd, 0, brepeat, block);
		}
		else{
			SetPriorityClass(GetCurrentProcess(), prioclass[prio]);
			bMinimize = 0;
			Indicate(hwnd, prio, brepeat, block);
		}
		break;
	case WM_DESTROY:
		KillTimer(hwnd, 1235);
		if(!bFullScreen){
			GetCurrentDirectory(MAX_PATH,path);
			strcat(path,"\\twload.ini");
			GetWindowRect(hwnd, &rWinSize);
			sprintf(s,"%i",rWinSize.left);
			WritePrivateProfileString("position", "x", s, path);
			sprintf(s,"%i",rWinSize.top);
			WritePrivateProfileString("position", "y", s, path);
		}
		break;
	case WM_LBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
		bl = 1;
		bclick = 0;
		if(block){
			block = 0;
			Indicate(hwnd, prio, brepeat, block);
		}
		break;
	case WM_LBUTTONUP:
		if(block) return DefWindowProc(hwnd, message, wparam, lparam);
		bl = 0;
		break;
	case WM_MBUTTONDOWN:
	case WM_MBUTTONDBLCLK:
		brepeat ^= 1;
		bm = 1;
		Indicate(hwnd, prio, brepeat, block);
		break;
	case WM_MBUTTONUP:
		bm = 0;
		break;
	case WM_RBUTTONDOWN:
	case WM_RBUTTONDBLCLK:
		br = 1;
		break;
	case WM_RBUTTONUP:
		br = 0;
		break;
	case WM_MOUSEWHEEL:
		if(bl){
			block = 1;
			Indicate(hwnd, prio, brepeat, block);
		}
		break;
	case WM_KEYDOWN:
		if(GetKeyState(VK_CONTROL) & 0x8000){
			if(wparam == VK_UP) prio ++;
			if(wparam == VK_DOWN) prio --;
			if(prio > 3) prio = 3;
			if(prio < 1) prio = 1;
			SetPriorityClass(GetCurrentProcess(), prioclass[prio]);
			Indicate(hwnd, prio, brepeat, block);
		}
		if(wparam == 'S' || wparam == 's'){
			if((GetKeyState(VK_CONTROL) & 0x8000) && (GetKeyState(VK_SHIFT) & 0x8000)){
				if(bFullScreen) OutBitmap(lpDDSPrim, 0);
				else OutBitmap(lpDDSBack, &rClientSize);
				return false;
			}
		}
		break;
	}
	return (*pWindowProc)(hwnd, message, wparam, lparam);
}

HRESULT WINAPI extSetHWnd(LPDIRECTDRAWCLIPPER lpddc, DWORD dwflags, HWND hwnd)
{
	HRESULT res;
	RECT rect;
	char path[MAX_PATH];

	res = (*pSetHWnd)(lpddc, dwflags, hwnd);

	if(pWindowProc) return res;

	GetClientRect(hwnd, &rect);
	GetCurrentDirectory(MAX_PATH, path);
	strcat(path, "\\twload.ini");
	rWinSize.left = GetPrivateProfileInt("position", "x", 0, path);
	rWinSize.top = GetPrivateProfileInt("position", "y", 0, path);
	rClientSize.top = 0;
	rClientSize.left = 0;
	if(rect.right > 790 && rect.right < 810){rect.right = 802; rClientSize.right = 800;}
	if(rect.right > 1014 && rect.right < 1034){rect.right = 1026; rClientSize.right = 1024;}
	if(rect.bottom > 590 && rect.bottom < 610){rect.bottom = 602; rClientSize.bottom = 600;}
	if(rect.bottom > 758 && rect.bottom < 778){rect.bottom = 770; rClientSize.bottom = 768;}
	SetWindowLong(hwnd, GWL_STYLE, GetWindowLong(hwnd, GWL_STYLE) | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_SYSMENU);
	AdjustWindowRect(&rect, WS_OVERLAPPEDWINDOW, FALSE);
	rWinSize.right = rect.right - rect.left;
	rWinSize.bottom = rect.bottom - rect.top;
	MoveWindow(hwnd,rWinSize.left + 2,rWinSize.top + 2,rWinSize.right - 5,rWinSize.bottom - 5,TRUE);
	pWindowProc = (WNDPROC)SetWindowLong(hwnd, GWL_WNDPROC, (LONG)extWindowProc);
	SetTimer(hwnd, 1234, 500, NULL);
	GetWindowText(hwnd, WinName, 128);

	return res;
}

HRESULT WINAPI extSetCooperativeLevel(LPDIRECTDRAW7 lpdd, HWND hwnd, DWORD dwflags)
{
	if(!pWindowProc && (dwflags & DDSCL_FULLSCREEN)){
		pWindowProc = (WNDPROC)SetWindowLong(hwnd, GWL_WNDPROC, (LONG)extWindowProc);
		GetWindowText(hwnd, WinName, 128);
		bFullScreen = 1;
		SetTimer(hwnd, 1235, 50, NULL);
	}
	return (*pSetCooperativeLevel)(lpdd, hwnd, dwflags);
}

HRESULT WINAPI extBlt(
	LPDIRECTDRAWSURFACE7 lpDDS,
	LPRECT lpDestRect,
	LPDIRECTDRAWSURFACE7 lpDDSrcSurface,
	LPRECT lpSrcRect,
	DWORD dwFlags,
	LPDDBLTFX lpDDBltFx
)
{
	if(lpDDS == lpDDSPrim) lpDDSBack = lpDDSrcSurface;
	if(lpDDS == lpDDSPrim && bMinimize){
		Sleep(500);
		return DD_OK;
	}
	return (*pBlt)(lpDDS, lpDestRect, lpDDSrcSurface, lpSrcRect, dwFlags, lpDDBltFx);
}

HRESULT WINAPI extFlip(
	LPDIRECTDRAWSURFACE7 lpDDS,
	LPDIRECTDRAWSURFACE7 lpDDSurfaceTargetOverride,
	DWORD dwFlags
)
{
	if(bMinimize){
		Sleep(500);
		return DD_OK;
	}
	return (*pFlip)(lpDDS, lpDDSurfaceTargetOverride, dwFlags);
}

HRESULT WINAPI extCreateSurface(
	LPDIRECTDRAW7 lpDD,
	LPDDSURFACEDESC2 lpDDSurfaceDesc2,
	LPDIRECTDRAWSURFACE7 FAR *lplpDDSurface,
	IUnknown FAR *pUnkOuter
)
{
	HRESULT res;
	res = (*pCreateSurface)(lpDD, lpDDSurfaceDesc2, lplpDDSurface, pUnkOuter);
	if(lpDDSurfaceDesc2->ddsCaps.dwCaps & DDSCAPS_PRIMARYSURFACE) lpDDSPrim = *lplpDDSurface;
	if(lpDDSurfaceDesc2->ddsCaps.dwCaps & DDSCAPS_FLIP) lpDDSPrim = *lplpDDSurface;
	if(!pBlt){
		pBlt = (Blt_Type)SetHook(*lplpDDSurface, 20, extBlt);
//		pFlip = (Flip_Type)SetHook(*lplpDDSurface, 44, extFlip);
	}
	return res;
}


BOOL APIENTRY DllMain( HANDLE hmodule, 
                       DWORD  dwreason,
                       LPVOID lpreserved
					 )
{
	char path[MAX_PATH];
	HINSTANCE hinst;
	DirectDrawCreateEx_Type pddcreate;
	DDSURFACEDESC2 ddsd;
	static LPDIRECTDRAW7 lpdd;
	LPDIRECTDRAWCLIPPER lpddc;

	switch(dwreason){
	case DLL_PROCESS_DETACH:
		lpdd->Release();
		return TRUE;
	case DLL_PROCESS_ATTACH:
		break;
	default:
		return TRUE;
	}

	GetSystemDirectory(path, MAX_PATH);
	strcat(path, "\\DSOUND.DLL");
	hinst = LoadLibrary(path);
	pDirectSoundCreate = (DirectSoundCreate_Type)GetProcAddress(hinst, "DirectSoundCreate");
	if(!pDirectSoundCreate) return FALSE;
	hinst = LoadLibrary("DDRAW.DLL");
	pddcreate = (DirectDrawCreateEx_Type)GetProcAddress(hinst, "DirectDrawCreateEx");
	(*pddcreate)(NULL, (void **)&lpdd, IID_IDirectDraw7, NULL);
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_HEIGHT | DDSD_WIDTH | DDSD_PIXELFORMAT | DDSD_REFRESHRATE;
	lpdd->GetDisplayMode(&ddsd);
	if(ddsd.ddpfPixelFormat.dwRGBBitCount != 16) lpdd->SetDisplayMode(ddsd.dwWidth, ddsd.dwHeight, 16, ddsd.dwRefreshRate, 0);
	pCreateSurface = (CreateSurface_Type)SetHook(lpdd, 24, extCreateSurface);
	pSetCooperativeLevel = (SetCooperativeLeve_Type)SetHook(lpdd, 80, extSetCooperativeLevel);
	lpdd->CreateClipper(0, &lpddc, 0);
	pSetHWnd = (SetHWnd_Type)SetHook(lpddc, 32, extSetHWnd);
	lpddc->Release();

    return TRUE;
}
